#include "stdio.h"

// mplayer's includes

#include "../version.h"

FILE *ine;
FILE *inl;
FILE *out;
FILE *cfg;
static char l[1024];
static char l2[1024];
static char str[1024];
static char str2[1024];
static char *t = NULL;
static char *n = 0;
int mode = 0;
static char *c;
int ln=0;

int defined(char *def)
{
    int ret;
//    printf("Watch for define: %s", def);
    ret = 0;
    rewind(cfg);
    while (t = fgets(l2, 1023, cfg)) {
	sscanf(l2, "#define %s", str2);
	if (strcmp(str2, def) == 0) {
	    ret = 1;
	    break;
	}
    };
//    if (ret) {
//	printf(" ... found \n");
//    } else {
//	printf(" ... not found\n");
//    }
    return ret;
}

void hlptxt(FILE * file, char * mask, int banner)
{
char* n2;
rewind(file);
ln=0;
// find help text beginning
    while (t = fgets(l, 1023, file)) {
	ln++;
	if (sscanf(l, mask, str))
	    break;
//    printf("%s\n",l);
    }
    mode = 0;
    while (t = fgets(l, 1023, file)) {
	if ((banner) && (n=strstr(l,"VERSION"))) {
	    *n=0;
	    n2=rindex(l,'\"');
	    if (n2) *n2=0;
	    sprintf(l2,"%s%s%s",l,VERSION,index(n+1,'\"')+1);
	    strcpy(l,l2);
	};
	    
	
	// cut off comments from line
	c = strstr(l, "//");
//    printf("\n%i\n",c);
        if (c) {
		*c = '\n';
		*(c+1) = 0;
	}

	if (l[strlen(l) - 2] == ';') {
	    l[strlen(l) - 2] = 0;
	    fprintf(out, "%s\n", l);
	    break;
	}
// obsolente
	if (sscanf(l, "#define MSGTR_%s", str))
	    break;
	if (mode == 9)
	    break;
// end obsolente

//    if ((l[0]=='\"')||(l[0]=='#')) switch (mode) {
	if (strlen(l))
	    switch (mode) {
	    case 0:		//normal - watch for #ifdef
		//#endif or blank for end 
		if (sscanf(l, "#ifdef %s", str)) {
//              printf("#ifdef %s found ...\n",str);
		    if (defined(str)) {
			mode = 1;
		    } else {
			mode = 3;
		    };
		} else {
		    if (sscanf(l, "#endif %s", str)) {
			mode = 9;
			break;
		    };
		    if (strlen(l) == 0) {
			mode = 9;
			break;
		    };
		    fprintf(out, "%s", l);
		}
		break;
	    case 1:		//ifdef active - wath for else or endif
		if (strstr(l, "#else"))
		    mode = 2;
		if (strstr(l, "#endif"))
		    mode = 0;
		if (mode == 1)
		    fprintf(out, "%s", l);
		break;
	    case 2:		//ifdef was active - skipping after else - watch for endif
		if (strstr(l, "#endif")) {
		    mode = 0;
		} else {
//              fprintf(out,"%s",l);
		}
		break;
	    case 3:		//ifdef not true - skipping after if - watch for else or endif
		if (strstr(l, "#else")) {
		    mode = 4;
		} else if (strstr(l, "#endif")) {
		    mode = 0;
		} else {
//              fprintf(out,"%s",l);
		}
		break;
	    case 4:		//ifdef not true - else active - watch for endif
		if (strstr(l, "#endif")) {
		    mode = 0;
		} else {
		    fprintf(out, "%s", l);
		}
		break;
	    }
    }

}



int main(int argc, char *argv[])
{

    if (argc<3) {
	printf("Usage: trans aa bb cccccc\nWhere aa is code of lang helpfile\n     bb is propriate country code\n     ccccc is encoding\nExample: trans cz cs ISO-8859-2\n");
	exit();
    }

    printf("Prg started.\n");

    ine = fopen("../help_mp-en.h", "r");
    if (!ine) {
	printf("Could not open eng file\n");
	exit();
    }

    printf("EN file opened.\n");

    sprintf(l,"../help_mp-%2s.h",argv[1]);

    inl = fopen(l, "r");
    if (!inl) {
	printf("Could not open trans file\n");
	exit();
    }
    printf("Translated MSG file opened.\n");
    
    sprintf(l,"%s.po",argv[2]);

    out = fopen(l, "w");
    if (!out) {
	printf("Could not open po file %s.\n",l);
	exit();
    }

    printf("PO file opened.\n");

    cfg = fopen("../config.h", "r");
    if (!cfg) {
	printf("Could not open cfg file\n");
	exit();
    }

    printf("CFG file opened.\n");

    fprintf(out, "# automatic convert to PO file\n#\n");
    fprintf(out, "msgid \"\"\n");
    fprintf(out, "msgstr \"\"\n");
    fprintf(out, "\"Project-Id-Version: mplayer\\n\"\n");
//fprintf(out,"\"POT-Creation-Date: 2002-04-26 15:31+0200\n\"\n");
//fprintf(out,"\"PO-Revision-Date: 2002-05-07 20:00+0200\n\"\n");
//    fprintf(out, "\"Last-Translator: Jiri Svoboda <Jiri.Svoboda@seznam.cz>\\n\"\n");
//    fprintf(out, "\"Language-Team: Czech <cs@li.org>\\n\"\n");
    fprintf(out, "\"MIME-Version: 1.0\\n\"\n");
    fprintf(out, "\"Content-Type: text/plain; charset=%s\\n\"\n",argv[3]);
    fprintf(out, "\"Content-Transfer-Encoding: 8bit\\n\"\n");
    fprintf(out, "\n");

    printf("Header in PO file written.\n");

    printf("First pass starting\n");

//  cycle for extracting messages
    ln=0;
    while (t = fgets(l, 1023, ine)) {
	ln++;
//	printf("Scanning ... ");
//	if (strlen(l)>5)
	if ((sscanf(l, "#define MSGTR_%s", str))) {
//	    printf("found source string id %s ", str);
	    fprintf(out, "#: help_mp-en.h:%i\n",ln);
	    fprintf(out, "msgid ");
	    n = l + strlen(str) + 14;
	    if (l[strlen(l) - 2] == '\\')
		fprintf(out, "\"\"\n");
	    while (l[strlen(l) - 2] == '\\') {
		l[strlen(l) - 2] = 0;
		fprintf(out, "%s\n", n);
		t = fgets(l, 1023, ine);
		ln++;
		// cut off comments from line
		c = strstr(l, "//");
		if (c) {
		    *c = '\n';
		    *(c+1) = 0;
		}
		n = index(l, '\"');
	    }
	    fprintf(out, "%s", n);
//	    printf(" EN-ok");
// translated messages
	    fprintf(out, "msgstr ");
	    
	    rewind(inl);
	    
	    while (t = fgets(l2, 1023, inl)) {
		// cut off comments from line
		c = strstr(l2, "//");
		if (c) {
		    *c = '\n';
		    *(c+1) = 0;
		}
		if (sscanf(l2, "#define MSGTR_%s", str2))
		    if (strcmp(str, str2) == 0) {
			n = l2 + strlen(str2) + 14;
			// if slash at the end we have to continue
			if (l2[strlen(l2) - 2] == '\\')
			    fprintf(out, "\"\"\n");
			while (l2[strlen(l2) - 2] == '\\') {
			    l2[strlen(l2) - 2] = 0;
			    fprintf(out, "%s\n", n);
			    fgets(l2, 1023, inl);
			    // cut off comments from line
			    c = strstr(l2, "//");
			    if (c) {
				*c = '\n';
				*(c+1) = 0;
				}
			    n = index(l2, '\"');
			}
			fprintf(out, "%s", n);
			fprintf(out, "\n");
		    }
	    }
//	    printf(" translated-DONE ");
// end transleted messages                  
	}
//	printf("line-done\n");
    }

    printf("Second pass starting\n");

// process the english part
    fprintf(out, "msgid \"\"\n");
    hlptxt(ine,"static char* banner_text%s",1);

// process the translated part
    fprintf(out, "\nmsgstr \"\"\n");
    hlptxt(inl,"static char* banner_text%s",1);

    fprintf(out, "\n");

// process the english part
    fprintf(out, "msgid \"\"\n");
    hlptxt(ine,"static char help_text%s",0);

// process the translated part
    fprintf(out, "\nmsgstr \"\"\n");
    hlptxt(inl,"static char help_text%s",0);

    fclose(cfg);
    fclose(inl);
    fclose(ine);
    fclose(out);
    printf("Finished\n");
}
